Subject: Re: [PATCH 2/2] format-patch: introduce format.defaultTo

From: Junio C Hamano <[email-masked]>
Date: Mon, 06 Jan 2014 14:22:59 -0800

Ramkumar Ramachandra <[email-masked]> writes:

> Junio C Hamano wrote:
>> I meant "a single branch" as opposed to "depending on what branch
>> you are sending out, you may have to use a different upstream
>> starting point", and a single "format.defaultTo" that does not read
>> what your HEAD currently points at may not be enough.
>>
>> Unless you set @{u} to this new configuration, in which case the
>> choice becomes dynamic depending on the current branch, but
>>
>>  - if that is the only sane choice based on the current branch, why
>>    not use that as the default without having to set the
>>    configuration?
>>
>>  - Or if that is still insufficient, don't we need branch.*.forkedFrom
>>    that is different from branch.*.merge, so that different branches
>>    you want to show "format-patch" output can have different
>>    reference points?
>
> Ah, I was going for an equivalent of merge.defaultToUpstream, but I
> guess branch.*.forkedFrom is a good way to go.

As I said in the different subthread, I am not convinced that you
would need the complexity of branch.*.forkedFrom.  If you set your
"upstream" to the true upstream (not your publishing point), and
have "remote.pushdefault" set to 'publish', you can expect

	git push

to do the right thing, and then always say

	git show-branch publish/topic topic

to see where your last published branch is relative to what you
have, no?  Mapping "topic@{publish}" to "refs/remotes/publish/topic"
(or when you have 'topic' checked out, mapping "@{publish}" to it)
is a trivial but is a separate usefulness, I would guess.